unit DP_Ben;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, ExtCtrls,
  ComCtrls, Buttons, DbCtrls, DBGrids, Grids, Menus, StdCtrls, ZConnection,
  ZDataset, ZSqlUpdate, db, IBConnection, sqldb, windows, Types;

type

  { TDPBen }

  TDPBen = class(TForm)
    Bevel1: TBevel;
    Bevel2: TBevel;
    Bevel3: TBevel;
    Bevel4: TBevel;
    Bevel5: TBevel;
    DBCan: TBitBtn;
    DBSav: TBitBtn;
    ChKw: TCheckBox;
    CB4: TDBCheckBox;
    CB3: TDBCheckBox;
    CB1: TDBCheckBox;
    CB2: TDBCheckBox;
    dUser: TDBEdit;
    DS1: TDataSource;
    dName: TDBEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    JvLED0: TImage;
    JvLED1: TImage;
    Label1: TLabel;
    dVorname: TDBEdit;
    Label3: TLabel;
    Label2: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    DBG1: TDBGrid;
    LiBo: TListBox;
    PG1: TPageControl;
    Panel1: TPanel;
    Panel2: TPanel;
    PB: TPanel;
    SuchPanel: TPanel;
    PA: TPanel;
    P3: TPanel;
    P4: TPanel;
    SortPanel: TPanel;
    P7: TPanel;
    SBar: TStatusBar;
    DBFirst: TSpeedButton;
    DBLoe: TSpeedButton;
    SpeedButton11: TSpeedButton;
    SpeedButton12: TSpeedButton;
    DBPrior: TSpeedButton;
    DBNext: TSpeedButton;
    DBLast: TSpeedButton;
    DBFil: TSpeedButton;
    DBDru: TSpeedButton;
    ExHome: TSpeedButton;
    DBNeu: TSpeedButton;
    DBAen: TSpeedButton;
    P1: TTabSheet;
    P2: TTabSheet;
    C1: TZConnection;
    Q1: TZQuery;
    procedure DBCanClick(Sender: TObject);
    procedure DBG1DblClick(Sender: TObject);
    procedure DBLoeClick(Sender: TObject);
    procedure DBSavClick(Sender: TObject);
    procedure DBFirstClick(Sender: TObject);
    procedure DBLastClick(Sender: TObject);
    procedure DBNextClick(Sender: TObject);
    procedure DBPriorClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure ExHomeClick(Sender: TObject);
    procedure DBNeuClick(Sender: TObject);
    procedure DBAenClick(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
    procedure BtnSet;
    procedure NeuUndBearbeiten;
    procedure BearbeitenModusVerlassen;
  end;

var
   xStatus        : boolean;                        // Bearbeitungsmodus
                                                    // True = Editieren
                                                    // False = Ansicht
                                                    // bei ChckBox Admin
                                                    // ergänzen der restl.
                                                    // beiden Felder
   Neu            : string;                         // Neuanlage = 'ja'
                                                    // Änderung = 'nein'
   Abbruch        : string;                         // Abbruch gedrückt
                                                    // = 'ja'
                                                    // nicht gedrückt
                                                    // = 'nein' (Standard)
   Datensatz      : Integer;                        // Record-Nr.
   UK_alt, VN_alt : string;                         // Userkennung (alt)
                                                    // Vorname (alt)

implementation

uses
    Main;                                           // Hauptformular

{$R *.lfm}

{ TDPBen }

//-------------------------------------------------------------------------
// 2.      Datenbearbeitung
//-------------------------------------------------------------------------
// 2.1.    Vorbereitung für Neueingaben und Bearbeitungsmodus
//-------------------------------------------------------------------------
procedure TDPBen.NeuUndBearbeiten;
begin
  if PG1.ActivePage = P1 then                       // wenn auf TAB "Übersicht"
    begin
      PG1.ActivePage  := P2;                        // Einzelanzeige aktiv setzen
    end;
  P1.Enabled          := False;                     // Übersicht deaktiviert
  P1.TabVisible       := False;                     // Übersichtstab ausblenden
  PA.Enabled          := False;                     // Button-Panel 1 inaktiv
  PB.Enabled          := False;                     // Button-PanelPanel 2 inaktiv
  SuchPanel.Enabled   := False;                     // "Such-"Panel inaktiv.
  SortPanel.Enabled   := False;                     // Indexauswahl inaktiv.
  ExHome.Enabled      := False;                     // Beenden inaktiv
  DBFil.Enabled       := False;                     // Filter Button inaktiv
  DBDru.Enabled       := False;                     // Drucker Button inaktiv
  DBSav.Enabled       := True;                      // Speichern aktiv
  DBCan.Enabled       := True;                      // Abbrechen aktiv
  xStatus             := True;                      // .... in Bearbeitung
  CB1.State           := cbUnChecked;               // kein Administrator
  CB2.Enabled         := True;                      // Checkbox aktiv
  CB3.Enabled         := True;                      // dto.
  CB4.Enabled         := True;                      // dto.
  Edit2.Text          := '';                        // KW = leeres Feld
  Edit3.Text          := '';                        // KW = leeres Feld
  dName.SetFocus;                                   // Cursor auf 1. Feld
  if Neu = 'ja' then                                // = neuer Datensatz
    begin
      DS1.DataSet.Append;                           // Datensatz anhängen
    end
  else                                              // Datenänderung
    begin
      DS1.DataSet.Edit;                             // Datensatz ändern
    end;
end;

//-------------------------------------------------------------------------
// 2.2.    Vorbereitung für das Verlassen des Bearbeitungsmodus (inkl. Neueingabe)
//-------------------------------------------------------------------------
procedure TDPBen.BearbeitenModusVerlassen;
begin
  P1.TabVisible       := True;                      // Übersichtstab anzeigen
  PG1.ActivePage      := P1;                        // Übersichtsseite aktiv
  P1.Enabled          := True;                      // Übersicht wieder anwählbar
  ExHome.Enabled      := True;                      // Beenden deaktivieren
  PA.Enabled          := True;                      // Button-Panel 1 aktiv
  PB.Enabled          := True;                      // Button-Panel 2 aktiv
  DBFil.Enabled       := True;                      // Filter Button deaktiv.
  DBDru.Enabled       := True;                      // Filter Button deaktiv.
  SuchPanel.Enabled   := True;                      // "Such-"Panel deaktiv.
  SortPanel.Enabled   := True;                      // Indexauswahl deaktiv.
  JvLED0.Visible      := False;                     // Kw Statusanzeige 1 aus
  JvLED1.Visible      := False;                     // Kw Statusanzeige 2 aus
  if DBSav.Visible = False then                     // wenn Speichern unsichtbar
    DBSav.Visible     := True;                      // -> Speicherbutton anzeigen
  DBSav.Enabled       := False;                     // "Speichern" inaktiv
  DBCan.Enabled       := False;                     // "Abbrechen" inaktiv
end;

//-------------------------------------------------------------------------
// 3.      Formularspezifische Funktionen und Prozeduren
//-------------------------------------------------------------------------
// 3.1.    Formular erzeugen
//-------------------------------------------------------------------------
procedure TDPBen.FormCreate(Sender: TObject);
begin
  PG1.ActivePage      := P1;                        // Übersichtsseite aktiv
  JvLED0.Visible 	  := False;                     // Statusanzeige aus
  JvLED1.Visible      := False;                     // Statusanzeige aus
  neu                 := 'nein';                    // = keine Neuanlage
  xStatus             := False;                     // Datenmenge nicht in
                                                    // Bearbeitung
  DBSav.Enabled       := False;                     // "Speichern" inaktiv
  DBCan.Enabled       := False;                     // "Abbrechen" inaktiv
  // -------------------- TZQuery und TZConnect einrichten ----------------
  DS1.DataSet         := Q1;
  Q1.Close;
  Q1.SQL.Clear;
  Q1.SQL.Text         := 'select * from ..................';
  Q1.IndexFieldNames  := 'Sortiername Asc';
  Q1.Connection       := C1;
  C1.AutoCommit       := False;
  C1.Database         := '.....................';
  C1.User             := '.........';
  C1.Password         := '.........';
  Q1.Active           := True;
  Q1.Open;
  C1.Connected        := True;
  BtnSet;
end;

//-------------------------------------------------------------------------
// 3.2.2.  Formular schließen
//-------------------------------------------------------------------------
procedure TDPBen.FormClose(Sender: TObject; var CloseAction: TCloseAction);
begin
  Q1.close;                                         // Datentabelle schließen
  C1.Connected := false;                            // Verbindung schließen
end;

//-------------------------------------------------------------------------
// 4.      Buttonbezogene Funktionen und Prozeduren
//-------------------------------------------------------------------------
// 4.1.    neuen Datensatz erfassen
//-------------------------------------------------------------------------
procedure TDPBen.DBNeuClick(Sender: TObject);
begin
  Neu := 'ja';                                      // = neuer Datensatz
  NeuUndBearbeiten;                                 // Vorbereiten zum
end;                                                // Neuanlegen / Ändern

//-------------------------------------------------------------------------
// 4.2.    bestehenden Datensatz bearbeiten
//-------------------------------------------------------------------------
procedure TDPBen.DBAenClick(Sender: TObject);
begin
  Neu := 'nein';                                    // Datensatz bearbeiten
  NeuUndBearbeiten;                                 // Vorbereiten zum
end;                                                // Neuanlegen / Ändern

//-------------------------------------------------------------------------
// 4.2.1.  bestehenden Datensatz aus DBGrid heraus bearbeiten
//-------------------------------------------------------------------------
procedure TDPBen.DBG1DblClick(Sender: TObject);     // Doppelklick in DBGrid
begin                                               // auf zu ändernden User
  dbAen.click;                                      // Datensatz ändern
end;

//-------------------------------------------------------------------------
// 4.3.    Datensatz löschen
//-------------------------------------------------------------------------
procedure TDPBen.DBLoeClick(Sender: TObject);
begin
        DS1.DataSet.Delete;                         // Datensatz löschen
        Q1.ApplyUpdates;
        C1.Commit;
end;

//-------------------------------------------------------------------------
// 4.4.    neuen / geänderten Datensatz speichern
//-------------------------------------------------------------------------
procedure TDPBen.DBSavClick(Sender: TObject);
begin
  DS1.DataSet.Post;                                 // Eingabe/Änderung abschl.
  Q1.ApplyUpdates;
  C1.Commit;
  BearbeitenModusVerlassen;
end;

//-------------------------------------------------------------------------
// 4.5.    Änderung abbrechen
//-------------------------------------------------------------------------
procedure TDPBen.DBCanClick(Sender: TObject);
begin
  DS1.DataSet.Cancel;                               // Bearbeitung abbrechen
  Abbruch := 'ja';                                  // Variable setzen
  BearbeitenModusVerlassen;
end;

//-------------------------------------------------------------------------
// 4.6     in der Datenbank blättern
//-------------------------------------------------------------------------
// 4.6.0.  Buttons zum Blättern aktivieren / deaktivieren
//-------------------------------------------------------------------------
procedure TDPBen.BtnSet;
begin
  if DS1.DataSet.EOF then                           // Ende der DB erreicht
    begin
      DBNext.Enabled   := False;                    // "Nächster" inaktiv
      DBLast.Enabled   := False;                    // "Letzter"  inaktiv
    end
  else                                              // Ende DB nicht erreicht
    begin
      DBNext.Enabled   := True;                     // "Nächster" aktiv
      DBLast.Enabled   := True;                     // "Letzter"  aktiv
    end;
  if DS1.DataSet.BOF then                           // Beginn der DB erreicht
    begin
      DBPrior.Enabled  := False;                    // "Vorheriger" inaktiv 
      DBFirst.Enabled  := False;                    // "Erster"     inaktiv
    end
  else                                              // Beginn DB nicht erreicht
    begin
      DBPrior.Enabled  := True;                     // "Vorheriger" aktiv
      DBFirst.Enabled  := True;                     // "Erster"     aktiv
    end;
end;

//-------------------------------------------------------------------------
// 4.6.1.  zum ersten Datensatz
//-------------------------------------------------------------------------
procedure TDPBen.DBFirstClick(Sender: TObject);
begin
  BtnSet;
  DS1.DataSet.First;                                // erster Datensatz
  BtnSet;
end;

//-------------------------------------------------------------------------
// 4.6.2.  zum letzten Datensatz
//-------------------------------------------------------------------------
procedure TDPBen.DBLastClick(Sender: TObject);
begin
  BtnSet;
  DS1.DataSet.Last;                                 // letzter Datensatz
  BtnSet;
end;

//-------------------------------------------------------------------------
// 4.6.3.  einen Datensatz vor
//-------------------------------------------------------------------------

procedure TDPBen.DBNextClick(Sender: TObject);
begin
  BtnSet;
  DS1.DataSet.Next;                                 // nächster Datensatz
  BtnSet;
end;

//-------------------------------------------------------------------------
// 4.6.4.  einen Datensatz zurück
//-------------------------------------------------------------------------
procedure TDPBen.DBPriorClick(Sender: TObject);
begin
  BtnSet;
  DS1.DataSet.Prior;                                // vorheriger Datensatz
  BtnSet;
end;

//-------------------------------------------------------------------------
// 4.7.    Benutzerdatenpflege beenden
//-------------------------------------------------------------------------
procedure TDPBen.ExHomeClick(Sender: TObject);
begin
  close;                                            // UNIT beenden
end;


end.

